package me.Destro168.ConfigManagers;

import me.Destro168.FC_Suite_Shared.ColorLib;
import me.Destro168.FC_Suite_Shared.FC_Suite_Shared;

import org.bukkit.ChatColor;
import org.bukkit.configuration.file.FileConfiguration;

public class ConfigManager 
{
	private FileConfiguration config;
	private ColorLib cLib = new ColorLib();
	
	public String ultimatePrefixTagText;
	public String primaryColor;
	public String secondaryColor;
	public String nameHighlightColor;
	public String errorColor;
	public String primaryHeaderColor;
	public String secondaryHeaderColor;
	public String bracketColor;

	public String primaryTag;
	public String secondaryTag;
	
	public String announcementTag;
	public String announcementTag2;
	
	public ConfigManager()
	{
		handleConfig();
	}
	
	public void handleConfig()
	{
		//Next we load up colors from the configuration file.
		config = FC_Suite_Shared.plugin.getConfig();
		
		if (config.getDouble("Version") < 1.0)
		{
			config.set("Version", 1.0);
			config.set("UltimatePrefixTagText", "FC");
			config.set("PrimaryColor", "&6");
			config.set("SecondaryColor", "&d");
			config.set("NameHighlightColor", "&2");
			config.set("ErrorColor", "&a");
			config.set("PrimaryHeaderColor", "&7");
			config.set("SecondaryHeaderColor", "&9");
			config.set("BracketColor", "&1");
		}
		
		//Load the configuration values.
		ultimatePrefixTagText = config.getString("UltimatePrefixTagText");
		primaryColor = config.getString("PrimaryColor");
		secondaryColor = config.getString("SecondaryColor");
		nameHighlightColor = config.getString("NameHighlightColor");
		errorColor = config.getString("ErrorColor");
		primaryHeaderColor = config.getString("PrimaryHeaderColor");
		secondaryHeaderColor = config.getString("SecondaryHeaderColor");
		bracketColor = config.getString("BracketColor");
		
		if (!ultimatePrefixTagText.equals("") && !ultimatePrefixTagText.equals("null"))
		{
			primaryTag = cLib.parseColors(bracketColor + "[" + primaryColor + ultimatePrefixTagText + bracketColor + "] " + primaryColor);
			secondaryTag = cLib.parseColors(bracketColor + "[" + secondaryColor + ultimatePrefixTagText + bracketColor + "] " + secondaryColor);
		}
		else
		{
			primaryTag = "";
			secondaryTag = "";
		}
		
		announcementTag = bracketColor + "[" + primaryColor + "Broadcast" + bracketColor + "] " + ChatColor.AQUA;
		announcementTag2 = bracketColor + "[" + errorColor + "Broadcast" + bracketColor + "] " + ChatColor.AQUA;
		
		FC_Suite_Shared.plugin.saveConfig();
	}
}
