package me.Destro168.Messaging;

import java.util.List;

import me.Destro168.ConfigManagers.ConfigManager;

import org.bukkit.ChatColor;
import org.bukkit.craftbukkit.command.ColouredConsoleSender;
import org.bukkit.entity.Player;

public class MessageLib extends BroadcastLib
{
	ConfigManager cm = new ConfigManager();
	Player player;
	ColouredConsoleSender console;
	
	public MessageLib(Player player_) { player = player_; console = null; }
	public MessageLib(ColouredConsoleSender console_) { console = console_; player = null; }
	
	public boolean successCommand()
	{
		return sendTheMessage(cm.primaryTag + "Successfully performed command!");
	}
	
	public boolean errorInvalidCommand()
	{
		return sendTheMessage(cm.secondaryTag + "Invalid Command Usage.");
	}
	
	public boolean errorNoPermission()
	{
		return sendTheMessage(cm.secondaryTag + "You do not have access to this command.");
	}
	
	public boolean errorPlayerNotOnline()
	{
		return sendTheMessage(cm.secondaryTag + "Player is not online!");
	}
	
	public boolean errorPlayerNotFound()
	{
		return sendTheMessage(cm.secondaryTag + "Player is not online!");
	}
	
	public boolean standardMessage(String msg)
	{
		//Highlight any useful information.
		msg = highlightNames(msg, cm.primaryTag);
		
		return sendTheMessage(cLib.parseColors(cm.primaryTag + msg));
	}
	
	public boolean standardMessage(String msg, String msg2)
	{
		//Highlight any useful information.
		msg = highlightNames(msg, cm.primaryColor);
		
		return sendTheMessage(cLib.parseColors(cm.primaryTag + msg + ": " + cm.secondaryColor + msg2));
	}
	
	public boolean secondaryMessage(String msg)
	{
		//Highlight any useful information.
		msg = highlightNames(msg, cm.secondaryColor);
		
		return sendTheMessage(cLib.parseColors(cm.secondaryTag + msg));
	}
	
	public boolean standardMessage(String[] msg)
	{
		//Variable Declarations
		String message = "";
		boolean alternate = true;
		
		//We want to alternate the colors for the standard  message.
		for (int i = 0; i < msg.length; i++)
		{
			if (i == 0)
			{
				message += cm.primaryColor + "" + msg[i];
			}
			else if (msg[i] != null)
			{
				if (alternate == true)
				{
					message += cm.secondaryColor + ", " + msg[i];
					alternate = false;
				}
				else if (alternate == false)
				{
					message += cm.primaryColor + ", " + msg[i];
					alternate = true;
				}
			}
		}
		
		//Highlight any useful information.
		message = highlightNames(message, cm.primaryColor);
		
		return sendTheMessage(cLib.parseColors(cm.primaryTag + message));
	}
	
	public boolean standardMessage(List<String> msg)
	{
		//Variable Declarations
		String message = "";
		boolean alternate = true;
		
		//We want to alternate the colors for the standard  message.
		for (int i = 0; i < msg.size(); i++)
		{
			if (i == 0)
			{
				message += cm.primaryColor + "" + msg.get(i);
			}
			else if (msg.get(i) != null)
			{
				if (alternate == true)
				{
					message += cm.secondaryColor + ", " + msg.get(i);
					alternate = false;
				}
				else if (alternate == false)
				{
					message += cm.primaryColor + ", " + msg.get(i);
					alternate = true;
				}
			}
		}
		
		//Highlight any useful information.
		message = highlightNames(message, cm.primaryColor);
		
		return sendTheMessage(cLib.parseColors(cm.primaryTag + message));
	}
	
	public boolean standardMessage(String msg, List<String> msg2)
	{
		//Variable Declarations
		String message = msg;
		boolean alternate = true;
		
		//We want to alternate the colors for the standard  message.
		for (int i = 0; i < msg2.size(); i++)
		{
			if (i == 0)
			{
				message += cm.primaryColor + "" + msg2.get(i);
			}
			else if (msg2.get(i) != null)
			{
				if (alternate == true)
				{
					message += cm.secondaryColor + ", " + msg2.get(i);
					alternate = false;
				}
				else if (alternate == false)
				{
					message += cm.primaryColor + ", " + msg2.get(i);
					alternate = true;
				}
			}
		}
		
		//Highlight any useful information.
		message = highlightNames(message, cm.primaryColor);
		
		return sendTheMessage(cLib.parseColors(cm.primaryTag + message));
	}
	
	public boolean standardError(String msg)
	{
		//Highlight any useful information.
		msg = highlightNames(msg, cm.errorColor);
		
		return sendTheMessage(cLib.parseColors(cm.errorColor + msg));
	}
	
	public boolean standardHeader(String msg)
	{
		return sendTheMessage(cLib.parseColors(cm.secondaryHeaderColor + ".: " + cm.primaryHeaderColor + ChatColor.ITALIC + ChatColor.BOLD + msg + cm.secondaryHeaderColor + " :."));
	}
	
	private boolean sendTheMessage(String msg)
	{
		if (player != null)
			player.sendMessage(msg);
		else if (console != null)
			console.sendMessage(msg);
		
		return true;
	}
}









